# -*- coding: utf-8 -*-
# (c) Copyright 2020 Sensirion AG, Switzerland

##############################################################################
##############################################################################
#                 _____         _    _ _______ _____ ____  _   _
#                / ____|   /\  | |  | |__   __|_   _/ __ \| \ | |
#               | |       /  \ | |  | |  | |    | || |  | |  \| |
#               | |      / /\ \| |  | |  | |    | || |  | | . ` |
#               | |____ / ____ \ |__| |  | |   _| || |__| | |\  |
#                \_____/_/    \_\____/   |_|  |_____\____/|_| \_|
#
#     THIS FILE IS AUTOMATICALLY GENERATED AND MUST NOT BE EDITED MANUALLY!
#
# Generator:    sensirion-shdlc-interface-generator 0.6.1
# Product:      SVM40
# Version:      0.2.0
#
##############################################################################
##############################################################################

# flake8: noqa

from __future__ import absolute_import, division, print_function
from sensirion_shdlc_driver.command import ShdlcCommand
from struct import pack, unpack

import logging
log = logging.getLogger(__name__)


class Svm40CmdStartMeasurementBase(ShdlcCommand):
    """
    SHDLC command 0x00: "Start Measurement".
    """

    def __init__(self, *args, **kwargs):
        super(Svm40CmdStartMeasurementBase, self).__init__(
            0x00, *args, **kwargs)


class Svm40CmdStartContinuousMeasurement(Svm40CmdStartMeasurementBase):

    def __init__(self):
        """
        Start Continuous Measurement Command

        Starts continuous measurement in polling mode.

        .. note:: This command is only available in idle mode.
        """
        super(Svm40CmdStartContinuousMeasurement, self).__init__(
            data=b"".join([bytes(bytearray([0x00]))]),
            max_response_time=0.05,
            post_processing_time=0.0,
            min_response_length=0,
            max_response_length=0
        )
